/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TInputLabel.TInputLabelPath;
import de.ship.db.tables.records.TCoreStageRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreStage extends TableImpl<TCoreStageRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_stage</code>
     */
    public static final TCoreStage T_CORE_STAGE = new TCoreStage();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreStageRecord> getRecordType() {
        return TCoreStageRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_stage.pk_core_stage</code>.
     */
    public final TableField<TCoreStageRecord, Integer> PK_CORE_STAGE = createField(DSL.name("pk_core_stage"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_stage.stage</code>. unique id of stage
     */
    public final TableField<TCoreStageRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER.nullable(false), this, "unique id of stage");

    /**
     * The column <code>common_dd.t_core_stage.stage_dev</code>. stage is
     * developement
     */
    public final TableField<TCoreStageRecord, Boolean> STAGE_DEV = createField(DSL.name("stage_dev"), SQLDataType.BOOLEAN.nullable(false), this, "stage is developement");

    /**
     * The column <code>common_dd.t_core_stage.stage_test</code>. stage is test
     */
    public final TableField<TCoreStageRecord, Boolean> STAGE_TEST = createField(DSL.name("stage_test"), SQLDataType.BOOLEAN.nullable(false), this, "stage is test");

    /**
     * The column <code>common_dd.t_core_stage.stage_prod</code>. stage is
     * productive
     */
    public final TableField<TCoreStageRecord, Boolean> STAGE_PROD = createField(DSL.name("stage_prod"), SQLDataType.BOOLEAN.nullable(false), this, "stage is productive");

    /**
     * The column <code>common_dd.t_core_stage.lastchange</code>.
     */
    public final TableField<TCoreStageRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_stage.stage_lang</code>.
     */
    public final TableField<TCoreStageRecord, String> STAGE_LANG = createField(DSL.name("stage_lang"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("'stage.none'::text"), SQLDataType.CLOB)), this, "");

    private TCoreStage(Name alias, Table<TCoreStageRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreStage(Name alias, Table<TCoreStageRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_stage</code> table reference
     */
    public TCoreStage(String alias) {
        this(DSL.name(alias), T_CORE_STAGE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_stage</code> table reference
     */
    public TCoreStage(Name alias) {
        this(alias, T_CORE_STAGE);
    }

    /**
     * Create a <code>common_dd.t_core_stage</code> table reference
     */
    public TCoreStage() {
        this(DSL.name("t_core_stage"), null);
    }

    public <O extends Record> TCoreStage(Table<O> path, ForeignKey<O, TCoreStageRecord> childPath, InverseForeignKey<O, TCoreStageRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_STAGE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreStagePath extends TCoreStage implements Path<TCoreStageRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreStagePath(Table<O> path, ForeignKey<O, TCoreStageRecord> childPath, InverseForeignKey<O, TCoreStageRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreStagePath(Name alias, Table<TCoreStageRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreStagePath as(String alias) {
            return new TCoreStagePath(DSL.name(alias), this);
        }

        @Override
        public TCoreStagePath as(Name alias) {
            return new TCoreStagePath(alias, this);
        }

        @Override
        public TCoreStagePath as(Table<?> alias) {
            return new TCoreStagePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreStageRecord, Integer> getIdentity() {
        return (Identity<TCoreStageRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreStageRecord> getPrimaryKey() {
        return Keys.PK_CORE_STAGE;
    }

    @Override
    public List<UniqueKey<TCoreStageRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_STAGE);
    }

    @Override
    public List<ForeignKey<TCoreStageRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_STAGE__FK_STAGE_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_STAGE__FK_STAGE_LANG, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY__FK_ELEMENT_STAGE.getInverseKey());

        return _tCoreElementHierarchy;
    }

    private transient TInputLabelPath _tInputLabel;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_label</code> table
     */
    public TInputLabelPath tInputLabel() {
        if (_tInputLabel == null)
            _tInputLabel = new TInputLabelPath(this, null, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_STAGE.getInverseKey());

        return _tInputLabel;
    }

    @Override
    public TCoreStage as(String alias) {
        return new TCoreStage(DSL.name(alias), this);
    }

    @Override
    public TCoreStage as(Name alias) {
        return new TCoreStage(alias, this);
    }

    @Override
    public TCoreStage as(Table<?> alias) {
        return new TCoreStage(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStage rename(String name) {
        return new TCoreStage(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStage rename(Name name) {
        return new TCoreStage(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStage rename(Table<?> name) {
        return new TCoreStage(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage where(Condition condition) {
        return new TCoreStage(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStage where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStage where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStage where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStage where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStage whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
